% Janela de Hamming

Tf=2000;

fn=-1:1/Tf:1;
Nf=length(fn);

N=51;
L=(N-1)/2;
Wp=0.25;

n=-L:L;
w=0.42+0.5*cos(2*pi*n/(N-1))+0.08*cos(4*pi*n/(N-1));
figure(1)
subplot(211)
hold off
plot(n,w);grid
xlabel('n')
title('Janela de Blackmann')

subplot(212)
hold off
W=0.42*sincd(pi*fn,N,1);
plot(fn,W);;grid
xlabel('\omega/\pi')
title('Transformada da janela de Blackmann')
hold
pause
Wad=0.25*sincd(pi*(fn-2/(N-1)),N,1)+0.25*sincd(pi*(fn+2/(N-1)),N,1);
plot(fn,Wad,'g','LineWidth',2);
pause
Wad2=0.04*sincd(pi*(fn-4/(N-1)),N,1)+0.04*sincd(pi*(fn+4/(N-1)),N,1);
plot(fn,Wad2,'c','LineWidth',2);
pause
plot(fn,W+Wad+Wad2,'m','LineWidth',2)
figure(2)

h=Wp*sinc(Wp*n);
H=freqz(h,1,pi*fn);
hblac=h.*w;
Hblac=freqz(hblac,1,pi*fn);grid
hold off
plot(fn,20*log10(abs(H)),'LineWidth',2);hold;grid;xlabel('\omega/\pi')
title('Filtros passa-baixas projetados com janelas retangular e de Blackmann')
plot(fn,20*log10(abs(Hblac)),'g','LineWidth',2)