% Fenomeno de Gibbs - convolucao entre transf. da janela retangular e
% passa-baixas ideal
%%% Vitor H. Nascimento - 04/04/2013

Tf=2000; % Espacamento entre frequencias
fn=-1:1/Tf:1;
N=21; % Comprimento do filtro, deve ser impar
L=(N-1)/2; % Atraso do filtro
W=0.25; % Frequencia de corte

Hd=zeros(size(fn));
Hd=(abs(fn)<W); % Resposta do filtro ideal
n=-L:L;
h=W*sinc(W*n);
H=freqz(h,1,pi*fn);

fn2=-2:1/Tf:2;
PL=sincd(pi*fn2,N,1); % Transformada da janela retangular

subplot(211)

Nf=length(fn);
Lf=(Nf-1)/2;
Lf2=(Nf-1)/2;
hold off
for fi=-0.5:10/Tf:0.5
    indx=round(Tf*(fi+1))+1;
    indy=round(Tf*(-fi+2))+1;
    subplot(211)
    hold off
    plot(fn,Hd,'LineWidth',2)
    xlabel('r/\pi')
    title('H_d(e^{jr}), (1/N)P_L(e^{j(\omega-r)})')
    hold on
    indWn=round(Tf*(-W+2))+1;
    indWp=round(Tf*(W+2))+1;
    indZn=round(Tf*(-fi+W+2))+1;
    indZp=round(Tf*(-fi-W+2))+1;
    stem(fn2(indWn:indWp),PL(indZp:indZn)/N,'c','MarkerSize',0)  
    axis([-1 1 -0.5  1.2])
    plot(fn,PL(indy-Lf:indy+Lf)/N,'r')
    subplot(212)    
    hold off
    plot(fn,abs(H));grid;xlabel('\omega/\pi');hold on
    plot(fn(indx),abs(H(indx)),'or','LineWidth',2)
    title('H(e^{j\omega})')
    axis([-1 1 0 1.2])
    pause
end