% Janela de Hamming
% Vitor H. Nascimento, 04/04/2013
Tf=2000;

fn=-1:1/Tf:1;
Nf=length(fn);

N=51;
L=(N-1)/2;
Wp=0.25;

n=-L:L;  % Janela sem contar atrasos.
w=0.54+0.46*cos(2*pi*n/(N-1));
figure(1)
subplot(211)
hold off
plot(n,w);grid
xlabel('n')
title('Janela de Hamming')
subplot(212)
hold off
W=0.54*sincd(pi*fn,N,1); % Transformada da janela retangular, 
plot(fn,W);grid
xlabel('\omega/\pi')
title('Transformada da janela de Hamming')
hold
pause
Wad=0.23*sincd(pi*(fn-2/(N-1)),N,1)+0.23*sincd(pi*(fn+2/(N-1)),N,1);
plot(fn,Wad,'g','LineWidth',2);
pause
plot(fn,W+Wad,'r','LineWidth',2);
pause
figure(2)
clf
h=Wp*sinc(Wp*n);
H=freqz(h,1,pi*fn);
hham=h.*w;
Hham=freqz(hham,1,pi*fn);
hold off
plot(fn,20*log10(abs(H)),'LineWidth',2);hold;xlabel('\omega/\pi')
title('Filtros passa-baixas projetados com janelas retangular e de Hamming')
plot(fn,20*log10(abs(Hham)),'g','LineWidth',2);grid