% Janela de Hamming - medida de valor eficaz
% Vitor H. Nascimento, 10/04/2013


wp=0.04; % cuidado, dividido por pi.
wr=0.1;

delta=5e-3;

deltapposdb=20*log10(1+delta);
deltapnegdb=20*log10(1-delta);
deltardb=20*log10(delta);

%N=ceil(3.3*2/(wr-wp))+1; % = 111

N=108;  
L=(N-1)/2;
Wp=(wp+wr)/2;

n=0:N-1;  % Janela contando atraso.
w=0.54-0.46*cos(2*pi*n/(N-1));
h=Wp*sinc(Wp*(n-L));
hham=h.*w;
[Hham,w]=freqz(hham,1,1000);
subplot(211)
hold off
plot(w/pi,20*log10(abs(Hham)),'LineWidth',2);grid
hold on
plot([0 wp],[deltapposdb deltapposdb],'g')
plot([0 wp],[deltapnegdb deltapnegdb],'g')
plot([wr 1],[deltardb deltardb],'r')
xlabel('\omega/\pi')
title('Filtro passa-baixas projetado com janela de Hamming')

subplot(223)
hold off
plot(w/pi,20*log10(abs(Hham)),'LineWidth',2);grid
hold on
plot([0 wp],[deltapposdb deltapposdb],'g')
plot([0 wp],[deltapnegdb deltapnegdb],'g')
plot([wr 1],[deltardb deltardb],'r')
axis([0 wp deltapnegdb deltapposdb])
xlabel('\omega/\pi')
title('Filtro passa-baixas projetado com janela de Hamming')

subplot(224)
hold off
plot(w/pi,20*log10(abs(Hham)),'LineWidth',2);grid
hold on
plot([0 wp],[deltapposdb deltapposdb],'g')
plot([0 wp],[deltapnegdb deltapnegdb],'g')
plot([wr 1],[deltardb deltardb],'r')
axis([wr 1 deltardb-30 deltardb])
xlabel('\omega/\pi')
title('Filtro passa-baixas projetado com janela de Hamming')

