% Comparao entre janelas Retangular, de von Hann, Hamming, Blackmann e
% Flat-top.
% Vitor H. Nascimento, 04/04/2013.

Tf=2000;

fn=-1:1/Tf:1;
Nf=length(fn);

N=51;
L=(N-1)/2;
Wp=0.25;

n=-L:L;
whan=0.5+0.5*cos(2*pi*n/(N-1));
wham=0.54+0.46*cos(2*pi*n/(N-1));
wblac=0.42+0.5*cos(2*pi*n/(N-1))+0.08*cos(4*pi*n/(N-1));
wflat=0.24726+0.46071*cos(2*pi*n/(N-1))+0.25078*cos(4*pi*n/(N-1))+0.04125*cos(6*pi*n/(N-1));
figure(1)
clf
plot(n,whan,n,wham,n,wblac,n,wflat);grid
xlabel('n')
title('Janelas de von Hann, Hamming, Blackmann e Flat-top')



h=sinc(Wp*n);
H=freqz(h,1,pi*fn);
hhan=h.*whan;
hham=h.*wham;
hblac=h.*wblac;
hflat=h.*wflat;
Hhan=freqz(hhan,1,pi*fn);
Hham=freqz(hham,1,pi*fn);
Hblac=freqz(hblac,1,pi*fn);
Hflat=freqz(hflat,1,pi*fn);
figure(2)
hold off
plot(fn,20*log10(abs(H)),'b','LineWidth',2);hold
plot(fn,20*log10(abs(Hhan)),'g','LineWidth',2);
plot(fn,20*log10(abs(Hham)),'r','LineWidth',2)
plot(fn,20*log10(abs(Hblac)),'m','LineWidth',2)
plot(fn,20*log10(abs(Hflat)),'c','LineWidth',2);
xlabel('\omega/\pi');grid
title('Filtros projetados com janelas Ret., Hann, Hamming, Blackmann e Flat-top')

figure(3)

W=sincd(pi*fn,N,1);
Wad=sincd(pi*(fn-2/(N-1)),N,1)+sincd(pi*(fn+2/(N-1)),N,1);
Wad2=sincd(pi*(fn-4/(N-1)),N,1)+sincd(pi*(fn+4/(N-1)),N,1);
Wad3=sincd(pi*(fn-6/(N-1)),N,1)+sincd(pi*(fn+6/(N-1)),N,1);

Wret=W;
Whann=0.5*W+0.25*Wad;
Whamm=0.54*W+0.23*Wad;
Wblac=0.42*W+0.25*Wad+0.04*Wad2;
Wflat=0.24726*W+0.46071/2*Wad+0.25078/2*Wad2+0.04125/2*Wad3;
plot(fn,W,fn,Whann,fn,Whamm,fn,Wblac,fn,Wflat)
xlabel('\omega/\pi');grid
title('Transformadas, janelas Ret., Hann, Hamming, Blackmann, Flat-top')






