function s=sincd(w,N,sim)
% Funo "sinc discreto", definida por sincd(w)=sen(wN/2)/sen(w/2).
% s=sind(w,N,sim)
% caso a sim seja definida, a funo ser discreta (como definido
% acima). Caso contrrio, ser dado um atraso de (N-1)/2.
% w pode ser um escalar ou um vetor de freqncias.

s=zeros(size(w));
for i=1:length(w)
  if w(i)~=0 & w(i) ~= 2*pi & w(i) ~= -2*pi
    s(i)=sin(N*w(i)/2)./sin(w(i)/2);
  else
    s(i)=N;
  end
end

if (~exist('sim','var'))
  s=s.*exp(-sqrt(-1)*w*(N-1)/2);
end





